﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel;

namespace howto_clone_with_serialization
{
    [TypeConverter(typeof(StreetAddressConverter))]
    [Serializable()]
    class StreetAddress : ICloneable
    {
        private string _Street;
        [Description("The street number, name, apartment number, etc. as in '123 N. Elm Ave Suite 21'")]
        public string Street
        {
            get
            {
                return _Street;
            }
            set
            {
                _Street = value;
            }
        }

        private string _City;
        [Description("The mailing address city")]
        public string City
        {
            get
            {
                return _City;
            }
            set
            {
                _City = value;
            }
        }

        private string _State;
        [Description("The two-letter state abbreviation")]
        public string State
        {
            get
            {
                return _State;
            }
            set
            {
                _State = value;
            }
        }

        private string _Zip;
        [Description("The postal ZIP or ZIP+4 code")]
        public string Zip
        {
            get
            {
                return _Zip;
            }
            set
            {
                _Zip = value;
            }
        }

        // Return as a comma-delimited string.
        public override string ToString()
        {
            return Street + "," + City + "," + State + "," + Zip;
        }

        #region ICloneable Members

        // This class has no reference type properties
        // so a shallow clone is the same as a deep clone.
        public object Clone()
        {
            return MemberwiseClone();
        }

        #endregion
    }
}
